DO I=0, N-1 
AB(17,9*I+1) = 2.E+0_DP*y(I+1)-2.E+0_DP*y(I)
AB(17,9*I+2) = 3.333333333333333E-1_DP*(2.E+0_DP&
	&*y(I+1)-2.E+0_DP*y(I))
AB(17,9*I+3) = 2.E-1_DP*(2.E+0_DP*y(I+1)-2.E+0_DP*y(I))
AB(17,9*I+4) = 1.4285714285714285E-1_DP*(2.E+0_DP&
	&*y(I+1)-2.E+0_DP*y(I))
AB(17,9*I+5) = 1.1111111111111112E-1_DP*(2.E+0_DP&
	&*y(I+1)-2.E+0_DP*y(I))
AB(17,9*I+6) = 9.090909090909092E-2_DP*(2.E+0_DP&
	&*y(I+1)-2.E+0_DP*y(I))
ENDDO 
DO I=1, N 

IF (9*I-17>0 ) AB(20,9*I-11) = 1.E+0_DP
IF ( N2>=9*I-2) AB(11,9*I-2) = -1.E+0_DP
IF ( N2>=9*I-2) AB(23,9*I-8) = -1.E+0_DP
IF ( N2>=9*I-2) AB(14,9*I+1) = 1.E+0_DP

IF (9*I-17>0 ) AB(21,9*I-11) = 1.E+0_DP
IF ( N2>=9*I-2) AB(12,9*I-2) = 1.E+0_DP
IF ( N2>=9*I-2) AB(22,9*I-7) = 1.E+0_DP
IF ( N2>=9*I-2) AB(13,9*I+2) = 1.E+0_DP
IF (9*I-16>0 ) AB(20,9*I-10) = (2.E+0_DP*y(I-1)-2.E&
	&+0_DP*y(I-2))/(y(I)-1.E+0_DP*y(I-1))
IF ( N2>=9*I-1) AB(11,9*I-1) = -2.E+0_DP
IF ( N2>=9*I-1) AB(23,9*I-7) = -2.E+0_DP
IF ( N2>=9*I-1) AB(14,9*I+2) = (2.E+0_DP*y(I)-2.E+0_DP&
	&*y(I-1))/(y(I+1)-1.E+0_DP*y(I))

IF (9*I-17>0 ) AB(22,9*I-11) = 1.E+0_DP
IF ( N2>=9*I-2) AB(13,9*I-2) = -1.E+0_DP
IF ( N2>=9*I-2) AB(21,9*I-6) = -1.E+0_DP
IF ( N2>=9*I-2) AB(12,9*I+3) = 1.E+0_DP
IF (9*I-16>0 ) AB(21,9*I-10) = (6.E+0_DP*y(I-1)-6.E&
	&+0_DP*y(I-2))/(y(I)-1.E+0_DP*y(I-1))
IF ( N2>=9*I-1) AB(12,9*I-1) = 6.E+0_DP
IF ( N2>=9*I-1) AB(22,9*I-6) = 6.E+0_DP
IF ( N2>=9*I-1) AB(13,9*I+3) = (6.E+0_DP*y(I)-6.E+0_DP&
	&*y(I-1))/(y(I+1)-1.E+0_DP*y(I))
IF (9*I-15>0 ) AB(20,9*I-9) = (y(I-1)*(1.2E+1_DP*y(I-1)-2.4E&
	&+1_DP*y(I-2))+1.2E+1_DP*y(I-2)**2)/(y(I)-1.E+0_DP*y(I-1))**2
IF ( N2>=9*I) AB(11,9*I) = -1.2E+1_DP
IF ( N2>=9*I) AB(23,9*I-6) = -1.2E+1_DP
IF ( N2>=9*I) AB(14,9*I+3) = (y(I)*(1.2E+1_DP*y(I)-2.4E+1_DP&
	&*y(I-1))+1.2E+1_DP*y(I-1)**2)/(y(I+1)-1.E+0_DP*y(I))**2

IF (9*I-17>0 ) AB(23,9*I-11) = 1.E+0_DP
IF ( N2>=9*I-2) AB(14,9*I-2) = 1.E+0_DP
IF ( N2>=9*I-2) AB(20,9*I-5) = 1.E+0_DP
IF ( N2>=9*I-2) AB(11,9*I+4) = 1.E+0_DP
IF (9*I-16>0 ) AB(22,9*I-10) = (1.2E+1_DP*y(I-1)-1.2E&
	&+1_DP*y(I-2))/(y(I)-1.E+0_DP*y(I-1))
IF ( N2>=9*I-1) AB(13,9*I-1) = -1.2E+1_DP
IF ( N2>=9*I-1) AB(21,9*I-5) = -1.2E+1_DP
IF ( N2>=9*I-1) AB(12,9*I+4) = (1.2E+1_DP*y(I)-1.2E+1_DP&
	&*y(I-1))/(y(I+1)-1.E+0_DP*y(I))
IF (9*I-15>0 ) AB(21,9*I-9) = (y(I-1)*(6.E+1_DP*y(I-1)-1.2E+2_DP&
	&*y(I-2))+6.E+1_DP*y(I-2)**2)/(y(I)-1.E+0_DP*y(I-1))**2
IF ( N2>=9*I) AB(12,9*I) = 6.E+1_DP
IF ( N2>=9*I) AB(22,9*I-5) = 6.E+1_DP
IF ( N2>=9*I) AB(13,9*I+4) = (y(I)*(6.E+1_DP*y(I)-1.2E+2_DP&
	&*y(I-1))+6.E+1_DP*y(I-1)**2)/(y(I+1)-1.E+0_DP*y(I))**2

IF (9*I-17>0 ) AB(24,9*I-11) = 1.E+0_DP
IF ( N2>=9*I-2) AB(15,9*I-2) = -1.E+0_DP
IF ( N2>=9*I-2) AB(19,9*I-4) = -1.E+0_DP
IF ( N2>=9*I-2) AB(10,9*I+5) = 1.E+0_DP
IF (9*I-16>0 ) AB(23,9*I-10) = (2.E+1_DP*y(I-1)-2.E&
	&+1_DP*y(I-2))/(y(I)-1.E+0_DP*y(I-1))
IF ( N2>=9*I-1) AB(14,9*I-1) = 2.E+1_DP
IF ( N2>=9*I-1) AB(20,9*I-4) = 2.E+1_DP
IF ( N2>=9*I-1) AB(11,9*I+5) = (2.E+1_DP*y(I)-2.E+1_DP&
	&*y(I-1))/(y(I+1)-1.E+0_DP*y(I))
IF (9*I-15>0 ) AB(22,9*I-9) = (y(I-1)*(1.8E+2_DP*y(I-1)-3.6E&
	&+2_DP*y(I-2))+1.8E+2_DP*y(I-2)**2)/(y(I)-1.E+0_DP*y(I-1))**2
IF ( N2>=9*I) AB(13,9*I) = -1.8E+2_DP
IF ( N2>=9*I) AB(21,9*I-4) = -1.8E+2_DP
IF ( N2>=9*I) AB(12,9*I+5) = (y(I)*(1.8E+2_DP*y(I)-3.6E+2_DP&
	&*y(I-1))+1.8E+2_DP*y(I-1)**2)/(y(I+1)-1.E+0_DP*y(I))**2

IF (9*I-17>0 ) AB(25,9*I-11) = 1.E+0_DP
IF ( N2>=9*I-2) AB(16,9*I-2) = 1.E+0_DP
IF ( N2>=9*I-2) AB(18,9*I-3) = 1.E+0_DP
IF ( N2>=9*I-2) AB(9,9*I+6) = 1.E+0_DP
IF (9*I-16>0 ) AB(24,9*I-10) = (3.E+1_DP*y(I-1)-3.E&
	&+1_DP*y(I-2))/(y(I)-1.E+0_DP*y(I-1))
IF ( N2>=9*I-1) AB(15,9*I-1) = -3.E+1_DP
IF ( N2>=9*I-1) AB(19,9*I-3) = -3.E+1_DP
IF ( N2>=9*I-1) AB(10,9*I+6) = (3.E+1_DP*y(I)-3.E+1_DP&
	&*y(I-1))/(y(I+1)-1.E+0_DP*y(I))
IF (9*I-15>0 ) AB(23,9*I-9) = (y(I-1)*(4.2E+2_DP*y(I-1)-8.4E&
	&+2_DP*y(I-2))+4.2E+2_DP*y(I-2)**2)/(y(I)-1.E+0_DP*y(I-1))**2
IF ( N2>=9*I) AB(14,9*I) = 4.2E+2_DP
IF ( N2>=9*I) AB(20,9*I-3) = 4.2E+2_DP
IF ( N2>=9*I) AB(11,9*I+6) = (y(I)*(4.2E+2_DP*y(I)-8.4E+2_DP&
	&*y(I-1))+4.2E+2_DP*y(I-1)**2)/(y(I+1)-1.E+0_DP*y(I))**2
ENDDO 
